SystemOrganization addCategory: #'Glamour-Browsers'!

GLMExplicitBrowser subclass: #GLMTabulator
	instanceVariableNames: 'cell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMTabulator methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addColumn: aBlockOrSymbol 
	 
	^self cellOrRow addColumn: aBlockOrSymbol! !

!GLMTabulator methodsFor: 'layout' stamp: 'tg 10/22/2009 13:27'!
addColumn: aBlockOrSymbol size: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) size: anInteger; span: 0! !

!GLMTabulator methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addColumn: aBlockOrSymbol span: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) span: anInteger! !

!GLMTabulator methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addRow: aBlockOrSymbol 
	 
	^self cellOrColumn addRow: aBlockOrSymbol! !

!GLMTabulator methodsFor: 'layout' stamp: 'tg 10/22/2009 13:27'!
addRow: aBlockOrSymbol size: anInteger 
	 
	^(self addRow: aBlockOrSymbol) size: anInteger; span: 0! !

!GLMTabulator methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
addRow: aBlockOrSymbol span: anInteger 
	 
	^(self addRow: aBlockOrSymbol) span: anInteger! !

!GLMTabulator methodsFor: 'layout' stamp: ' 4/5/09 22:18'!
cell 
	 
	^cell! !

!GLMTabulator methodsFor: 'private' stamp: ' 4/5/09 22:18'!
cellOrColumn 
	 
	^cell ifNil: [cell := GLMCustomColumn new browser: self]! !

!GLMTabulator methodsFor: 'private' stamp: ' 4/5/09 22:18'!
cellOrRow 
	 
	^cell ifNil: [cell := GLMCustomRow new browser: self]! !

!GLMTabulator methodsFor: 'rendering' stamp: 'tg 1/10/2010 16:20'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderTabulator: self! !

Announcement subclass: #GLMPaneAnnouncement
	instanceVariableNames: 'pane browser position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

GLMPaneAnnouncement subclass: #GLMPaneAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMPaneAnnouncement classSide methodsFor: 'instance creation' stamp: 'tg 1/18/2010 11:08'!
pane: aPane atPosition: anInteger inBrowser: aBrowser 
	 
	^(self new) 
		pane: aPane; 
		position: anInteger; 
		browser: aBrowser; 
		yourself! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
browser 
	 
	^browser! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
browser: anObject 
	 
	browser := anObject! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
pane 
	 
	^pane! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
pane: anObject 
	 
	pane := anObject! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
position 
	 
	^position! !

!GLMPaneAnnouncement methodsFor: 'accessing' stamp: 'tg 1/18/2010 11:06'!
position: anObject 
	 
	position := anObject! !

GLMPaneAnnouncement subclass: #GLMPaneRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMPaneRemoved classSide methodsFor: 'instance creation' stamp: ' 4/5/09 22:18'!
pane: aPane fromBrowser: aBrowser 
	 
	^(self new) 
		pane: aPane; 
		browser: aBrowser; 
		yourself! !

GLMPaneAnnouncement subclass: #GLMPaneSelected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

GLMImplicitBrowser subclass: #GLMAccumulator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMAccumulator commentStamp: 'tg 1/19/2010 21:28' prior: 0!
An GLMAccumulator is an implicit type of browser that has the following behavior:
- each input entity has associated a pane without any relationship with the other panes
- based on the input entity if there already exists a pane associated, it is selected via GLMPaneSelected
- if there isnt a pane, a new pane is created
- based on entityToSelect, the associated pane is searched and potentially selected

Input ports:
- entity
- entityToSelect

Output ports:
- selection!

!GLMAccumulator methodsFor: 'private' stamp: 'tg 1/19/2010 21:50'!
addPaneFrom: aPort 
	| lastActivePresentation |
	(self tryToSelectPaneFrom: aPort) ifTrue: [ ^ self ].
	self panes addLast: (GLMPane in: self).
	GLMTransmission new
		ensureBundleStrategy;
		addActiveOrigin: aPort; 
		destination: (self panes last port: #entity); 
		presentations: (self presentations copy); 
		transmit.
	self announce: 
			(GLMPaneAdded 
				pane: self panes last 
				atPosition: self panes size 
				inBrowser: self)! !

!GLMAccumulator methodsFor: 'accessing ports' stamp: 'tg 1/19/2010 21:24'!
entityToSelect: anObject
	^ (self pane port: #entityToSelect) value: anObject ! !

!GLMAccumulator methodsFor: 'events' stamp: 'tg 1/18/2010 07:47'!
innerPortEvent: aPortEvent 
	aPortEvent portName = #entity ifFalse: [
		"We don't want to resend the transmission, but use a new SimpleTransmission." 
		(self pane port: aPortEvent portName) value: aPortEvent value]! !

!GLMAccumulator methodsFor: 'events' stamp: 'tg 1/19/2010 21:23'!
outerPortEvent: aPortEvent 
 	super outerPortEvent: aPortEvent.
	aPortEvent port name = #entityToSelect ifTrue: [
		self tryToSelectPaneFrom: aPortEvent port ].	
	aPortEvent port name = #entity ifTrue: [
		self addPaneFrom: aPortEvent port ]! !

!GLMAccumulator methodsFor: 'private' stamp: 'tg 1/18/2010 08:41'!
removePaneIndex: i
	| paneRemoved |
	paneRemoved := self panes removeAt: i.
	self announce: (GLMPaneRemoved pane: paneRemoved fromBrowser: self )! !

!GLMAccumulator methodsFor: 'rendering' stamp: 'tg 1/18/2010 08:36'!
renderGlamorouslyOn: aRenderer
	^ aRenderer renderAccumulator: self! !

!GLMAccumulator methodsFor: 'private' stamp: 'tg 1/19/2010 21:50'!
tryToSelectPaneFrom: aPort
	self panes withIndexDo: [:each :i | 
		(each port: #entity) value = aPort value ifTrue: [
			self announce: 
				(GLMPaneSelected 
					pane: each 
					atPosition: i
					inBrowser: self).
			^ true ] ].
	^ false! !

GLMImplicitBrowser subclass: #GLMFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMFinder commentStamp: 'tg 1/26/2010 12:41' prior: 0!
A GLMFinder models a browsers that behaves like the Mac Finder: whenever the selection port is set on one pane, a new one is created to the right with the selection as entity. The Finder opens the first pane on the entity.

Input ports:
- entity: this is passed to the first pane

Output ports:
- selection: this port is populated with the value from the last selection port from one of the panes!

!GLMFinder methodsFor: 'private' stamp: 'tg 1/15/2010 02:48'!
addPaneFrom: aPort 
	| lastActivePresentation |
	self panes addLast: (GLMPane in: self).
	GLMTransmission new
		ensureBundleStrategy;
		addActiveOrigin: aPort; 
		destination: (self panes last port: #entity); 
		presentations: (self presentations copy); 
		transmit.
	self announce: 
			(GLMPaneAdded 
				pane: self panes last 
				atPosition: self panes size 
				inBrowser: self)! !

!GLMFinder methodsFor: 'private' stamp: 'tg 1/15/2010 02:48'!
addPaneFromInner: aPort 
	| newTransmission realTransmissions lastActivePresentation |
	"the lastActivePresentation is needed for knowing what presentation to show by default"
	self panes isEmpty ifFalse: [lastActivePresentation := self panes last lastActivePresentation ].
	self panes addLast: ( (GLMPane in: self) lastActivePresentation: lastActivePresentation; yourself).
	GLMTransmission new
		ensureBundleStrategy;
		addActiveOrigin: aPort; 
		destination: (self panes last port: #entity); 
		presentations: (self presentations copy); 
		transmit. 
	realTransmissions := self transmissions collect: [:each |  
			newTransmission := GLMTransmission new ensureBundleStrategy. 
			each activeOrigins do: [:eachPort | 
				newTransmission addActiveOrigin: (aPort pane port: eachPort name)]. 
			each passiveOrigins do: [:eachPort | 
				newTransmission addPassiveOrigin: (aPort pane port: eachPort name)]. 
			newTransmission 
				destination: (self panes last port: #entity); 
				addPresentations: (self presentations collect: #copy);
				addPresentations: (each presentations collect: #copy)] . 
	(realTransmissions select: [:each | each originatesAt: aPort]) 
		do: [:each | each transmit]. 
	self 
		announce: 
			(GLMPaneAdded 
				pane: self panes last 
				atPosition: self panes size 
				inBrowser: self)! !

!GLMFinder methodsFor: 'events' stamp: 'tg 1/31/2010 01:08'!
innerPortEvent: aPortEvent 
	 
	aPortEvent portName = #entity ifFalse: [
		"We don't want to resend the transmission, but use a new SimpleTransmission." 
		(self pane port: aPortEvent portName) value: aPortEvent value]. 
	aPortEvent port name = #selection ifTrue: [
		(self panes reverse copyUpTo: aPortEvent pane) do: [ :each |  
			self removeLastPane.
			self announce: (GLMPaneRemoved pane: each fromBrowser: self) ]. 
		self addPaneFromInner: aPortEvent port ]! !

!GLMFinder methodsFor: 'events' stamp: ' 4/5/09 22:18'!
outerPortEvent: aPortEvent 
	 
	aPortEvent port name = #entity ifFalse: [^self]. 
	panes := nil. 
	self addPaneFrom: aPortEvent port! !

!GLMFinder methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderFinder: self! !

Object subclass: #GLMCustomCell
	instanceVariableNames: 'children span id browser size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser 
	 
	^browser! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser: anObject 
	 
	browser := anObject! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
children 
	 
	^children ifNil: [children := OrderedCollection new]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
children: anObject 
	 
	children := anObject! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
childrenCount 
	 
	^self children 
		inject: 0 
		into: [:sum :each | sum + each span]! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasId 
	 
	^id notNil! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
id 
	 
	^id ifNil: [#anonymous]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
id: anObject 
	 
	id := anObject! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isColumn 
	 
	^false! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isRow 
	 
	^false! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isSplitIntoColumns 
	 
	^self children allSatisfy: [:each | each isColumn]! !

!GLMCustomCell methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isSplitIntoRows 
	 
	^self children allSatisfy: [:each | each isRow]! !

!GLMCustomCell methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:17'!
size
	^ size ifNil: [0]! !

!GLMCustomCell methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:20'!
size: anObject
	size := anObject.! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
span 
	 
	^span ifNil: [span := 1]! !

!GLMCustomCell methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
span: anObject 
	 
	span := anObject! !

GLMCustomCell subclass: #GLMCustomColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomColumn methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 21:53'!
addRow: aBlockOrSymbol 
	 
	| newRow cell | 
	cell := aBlockOrSymbol isSymbol 
		ifTrue: 
			[self browser 
				addNewPaneNamed: aBlockOrSymbol. 
			(GLMCustomRow new) 
				id: aBlockOrSymbol; 
				browser: self browser] 
		ifFalse: 
			[newRow := GLMCustomRow new browser: self browser. 
			aBlockOrSymbol value: newRow. 
			newRow]. 
	self children addLast: cell. 
	^cell! !

!GLMCustomColumn methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:20'!
addRow: aBlockOrSymbol size: anInteger 
	 
	^(self addRow: aBlockOrSymbol) size: anInteger; span: 0! !

!GLMCustomColumn methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:20'!
addRow: aBlockOrSymbol span: anInteger 
	 
	^(self addRow: aBlockOrSymbol) span: anInteger; size: 0! !

!GLMCustomColumn methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isColumn 
	 
	^true! !

GLMCustomCell subclass: #GLMCustomRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Browsers'!

!GLMCustomRow methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 21:49'!
addColumn: aBlockOrSymbol 
	 
	| newColumn cell | 
	cell := aBlockOrSymbol isSymbol 
		ifTrue: 
			[self browser 
				addNewPaneNamed: aBlockOrSymbol. 
			(GLMCustomColumn new) 
				id: aBlockOrSymbol; 
				browser: self browser] 
		ifFalse: 
			[newColumn := GLMCustomColumn new browser: self browser. 
			aBlockOrSymbol value: newColumn. 
			newColumn]. 
	self children addLast: cell. 
	^cell! !

!GLMCustomRow methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:21'!
addColumn: aBlockOrSymbol size: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) size: anInteger; span: 0! !

!GLMCustomRow methodsFor: 'accessing' stamp: 'tg 10/22/2009 10:21'!
addColumn: aBlockOrSymbol span: anInteger 
	 
	^(self addColumn: aBlockOrSymbol) span: anInteger; size: 0! !

!GLMCustomRow methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isRow 
	 
	^true! !
